import React, { PureComponent } from 'react';
export const ARROW_TYPES = {
  prev: 'prev',
  next: 'next'
};
export class Arrow extends PureComponent {
  get cssClass() {
    const _this$props = this.props,
          className = _this$props.className,
          arrowType = _this$props.arrowType;
    const customClassName = !className ? '' : `${className} ${arrowType ? `${className}--${arrowType}` : ''}`;
    return `rcc-Arrow ${arrowType ? `rcc-Arrow--${arrowType}` : ''} ${customClassName}`;
  }

  render() {
    const _this$props2 = this.props,
          onClick = _this$props2.onClick,
          component = _this$props2.component,
          arrowType = _this$props2.arrowType;
    const ArrowComponent = component;
    return React.createElement("div", {
      className: this.cssClass
    }, React.createElement(ArrowComponent, {
      onClick: onClick,
      arrowType: arrowType
    }));
  }

}