import React, { PureComponent } from 'react';
import { DotsDot } from './DotsDot';
export class Dots extends PureComponent {
  get cssClass() {
    const className = this.props.className;
    return `rcc-Dots ${className || ''}`;
  }

  render() {
    const _this$props = this.props,
          onDotClick = _this$props.onDotClick,
          currentIndex = _this$props.currentIndex,
          itemsCount = _this$props.itemsCount,
          dotComponent = _this$props.dotComponent,
          dotWrapperClassName = _this$props.dotWrapperClassName;
    const indexes = [...Array(itemsCount).keys()];
    return React.createElement("div", {
      className: this.cssClass
    }, indexes.map(index => React.createElement(DotsDot, {
      key: index,
      index: index,
      component: dotComponent,
      onClick: onDotClick,
      current: currentIndex === index,
      className: dotWrapperClassName
    })));
  }

}